<template>
    <div>
        <v-col sm="2" offset="10">
            <v-text-field
                    v-model="search"
                    append-icon="mdi-magnify"
                    label="Rechercher un point"
                    single-line
                    hide-details
            ></v-text-field>
        </v-col>
        <v-data-table :items="points" :headers="headers" :search="search" :items-per-page=25 item-key="id"
        >
            <template v-slot:body="{ items }">
                <tbody>
                <tr v-for="(item) in items" :key="item.id" :class="colorRow(item.status_work)">
                    <td>{{item.fic}}</td>
                    <td :class="colorUrgence(item.urgence)" class="urgence">{{item.urgence}}</td>
                    <td>{{item.coupure}}</td>
                    <td>{{item.distance_sc}}</td>
                    <td>{{item.distance_to_do}}</td>
                    <td>{{item.distance_done}}</td>
                    <td>{{item.abattage}}</td>
                    <td>{{item.access}}</td>
                    <td>{{item.essence}}</td>
                    <td>{{item.observation}}</td>
                    <td>{{item.type_work |textMoyens(moyens)}}</td>
                    <td>{{item.timestamp | formatDate}}</td>
                    <td>{{item.responsable}}</td>
                    <td>
                        <v-icon small class="mr-2" @click="editPoint(item)">mdi-pencil</v-icon>
                    </td>
                </tr>
                </tbody>
            </template>
        </v-data-table>
        <div>
            <v-dialog v-model="dialog" max-width="500px">
                <template v-slot:activator="{ on }">
                    <v-btn color="green" dark class="mb-2" v-on="on">Modifier le point</v-btn>
                </template>
                <v-card>
                    <v-card-title>
                        <span class="headline">Modifier le point {{editedPoint.fic}}</span>
                    </v-card-title>
                    <v-card-text>
                        <v-container>
                            <v-row>
                                <v-col cols="12" sm="12" md="12">
                                    <v-textarea auto-grow rows="1" v-model="editedPoint.observation"
                                                label="Observation"></v-textarea>
                                </v-col>
                                <v-col cols="12" sm="6" md="6">
                                    <v-text-field type="number" v-model.number="editedPoint.coupure"
                                                  label="Temps coupure(min)"></v-text-field>
                                </v-col>
                                <v-col cols="12" sm="6" md="6">
                                    <v-text-field type="number" v-model.number="editedPoint.distance_sc"
                                                  label="Distance sous coupure"></v-text-field>
                                </v-col>
                                <v-col>
                                    <v-select :items="moyens" :item-value="value" :item-text="text"
                                              v-model="editedPoint.type_work"></v-select>
                                </v-col>
                            </v-row>
                        </v-container>
                    </v-card-text>

                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="brown darken-1" text @click="close">Annuler</v-btn>
                        <v-btn color="brown darken-1" text @click="savePoint">Enregistrer</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </div>
    </div>
</template>
<script>
    import moment from "moment";
    import axios from "../plugins/axios";

    export default {
        name: 'TablePoint',
        props: {
            points: [],
        },
        data: () => ({
            search: '',
            headers: [
                {
                    text: 'FIC',
                    value: 'fic',
                    align: 'center'
                },
                {
                    text: 'Urgence',
                    value: 'urgence',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Coupure',
                    value: 'coupure',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Longueur coupure',
                    value: 'distance_sc'
                },
                {
                    text: 'Longueur',
                    value: 'distance_to_do',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Longueur faite',
                    value: 'distance_done',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Abattage',
                    value: 'abattage',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Accès',
                    value: 'access',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Essence',
                    value: 'essence',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Observation',
                    value: 'observation',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Moyens',
                    value: 'type_work',
                    align: 'center',
                    filterable: false
                },
                {
                    text: 'Date',
                    value: 'timestamp',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Responsable',
                    value: 'responsable',
                    align: 'center',
                    filterable: false,
                },
                {
                    text: 'Action',
                    align: 'center',
                    value: 'actions',
                    filterable: false
                }
            ],
            defaultPoint: {
                id: null,
                depart_id: null,
                urgence: "",
                coupure: 0,
                distance_to_do: 0,
                distance_done: 0,
                abattage: 0,
                access: 1,
                surlargeur: 0,
                observation: "",
                status_work: 2,
                essence: "CHENE",
                distance_sc: 0,
                timestamp: 0,
                fic: 1,
                accord: 2,
                latitude: 0,
                longitude: 0,
                type_work: 0
            },
            editedPoint: {
                id: null,
                depart_id: null,
                urgence: "",
                coupure: 0,
                distance_to_do: 0,
                distance_done: 0,
                abattage: 0,
                access: 1,
                surlargeur: 0,
                observation: "",
                status_work: 2,
                essence: "CHENE",
                distance_sc: 0,
                timestamp: 0,
                fic: 1,
                accord: 2,
                latitude: 0,
                longitude: 0,
                type_work: 0
            },
            editedIndex: -1,
            dialog: false,
            moyens: [
                {
                    text: 'Non défini',
                    value: 0,
                },
                {
                    text: 'Jarraff',
                    value: 1,
                },
                {
                    text: 'Nacelle',
                    value: 2,
                },
                {
                    text: 'Manuel',
                    value: 3,
                },
                {
                    text: 'Lamier',
                    value: 4,
                },
                {
                    text: 'Grimpe',
                    value: 5,
                },
            ]
        }),
        methods: {
            colorRow(status_work) {
                if (status_work === 0) {
                    return 'white '
                } else if (status_work === 1) {
                    return 'yellow'
                } else if (status_work === 2) {
                    return 'blue white--text'
                }
            },
            colorUrgence(urgence) {
                switch (urgence) {
                    case "U1 - 0,60/2m":
                    case "U1":
                        return 'orange--text'
                    case "U0 - 0/60Cm":
                    case "U0":
                        return 'red--text'
                    default:
                        return 'black--text'
                }
            },
            editPoint(point) {
                this.editedIndex = this.points.indexOf(point)
                this.editedPoint = Object.assign({}, point)
                this.dialog = true
            },
            savePoint() {
                let point = this.editedPoint
                this.points[this.editedIndex] = point
                axios.patch('/points/' + point.id, point ).then(() => {
                    this.editedPoint = this.defaultPoint
                    this.editedIndex = -1
                    this.dialog = false
                }).catch(() => {

                })
            }
        },
        filters: {
            formatDate(value) {
                if (value) {
                    return moment.unix(value / 1000).format("DD/MM/YYYY");
                }
            },
            textMoyens(value, moyens) {
                try{
                    if (value === "0" || value === "") {
                        return ""
                    }
                    return moyens[value].text
                }catch (e) {
                    return ""
                }
            }
        },
        watch: {
            dialog(val) {
                val || this.close()
            },
        },
    }
</script>
<style scoped>
    .urgence {
        font-weight: bold;
    }
</style>